# -*- coding: latin-1 -*-
#    QUENLIG: Questionnaire en ligne (Online interactive tutorial)
#    Copyright (C) 2005-2006 Thierry EXCOFFIER, Universite Claude Bernard
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#    Contact: Thierry.EXCOFFIER@bat710.univ-lyon1.fr
#

from questions import *
from check import *

add(name="intro",
    required=["manuel:chercher"],
    question="""Quel est le nom de la commande permettant
    d'afficher le nombre de caractres, mots et lignes
    de fichiers ou lu dans son entre standard&nbsp;?""",
    tests=(
    good("wc"),
    ),
    indices=(
    "C'est l'abrviation de <em>word count</em>",
    ),
    )

add(name="ligne",
    question="""Quelle commande devez-vous taper pour n'afficher
    que le nombre de lignes contenues dans <tt>/etc/passwd</tt>""",
    tests=(
    shell_good("wc -l /etc/passwd"),
    shell_good("wc -l </etc/passwd"),
    require("/etc/passwd",
            """Le nombre de ligne de <tt>/etc/passwd</tt>,
            pas de l'entre standard."""),
    shell_display,
    ),
    indices=(
    "Lisez la doc affiche par&nbsp;: <tt>wc --help</tt> ou <tt>man wc</tt>",
    )
    )


